
#include <string.h>
#include <dos.h>
#include "bob.h"

#ifndef __TURBOC__
  #define asm _asm
 
#endif

#ifndef BP_COMP

#include "usedll.h"


/*    {"LoadLibrary",loadlib},
    {"GetProcAddress",getproc},
    {"CallLibFunc",calldll},
    {"FreeLibrary",freelib} */




extern int argcount(int n, int cnt);

static const char* dllerrs[] = {
"Success",
"invalid argument",
"not enough memory",
"DLL not found",
"error opening DLL",
"error reading DLL",
"error loading DLL",
"entry point not found",
"symbol not found",
"invalid symbol index",
"unknown DLL error"
};

int loadlib(int argc)
{
   char name[200];
   HDLL plib;
   argcount(argc,1);
   chktype(0,DT_STRING);
   getcstring(name,sizeof(name),sp[0].v.v_string);
   plib = LoadLibrary(name);
   ++sp;
   if (plib)
     set_farptr(&sp[0],plib);
   else
   {
     set_nil(&sp[0]);
     error("%s (%s)",dllerrs[GetDllError()],name);
   }
   return 1;
}

int getproc(int argc)
{
   char name[200];
   HDLL plib;
   PDLLPROC pproc;
   argcount(argc,2);
   chktype(1,DT_INTEGER);
   chktype(0,DT_STRING);
   getcstring(name,sizeof(name),sp[0].v.v_string);
   plib = (HDLL) sp[1].v.v_far;
   pproc = GetProcAddress(plib,name);
   sp += 2;
   if (pproc)
     set_farptr(&sp[0],pproc);
   else
   {
     set_nil(&sp[0]);
     error("%s (%s)",dllerrs[GetDllError()],name);
   }
   return 1;
}

typedef long (huge *FARPROC)();

struct RESSTRUCT
{
   int lw;
   int hw;
};

int calldll(int argc)
{
   FARPROC proc;
   int procargc;
   int i, rl, rh;
   long* pargs;
   long lresult;
   struct RESSTRUCT result = { 0, 0};
        if (argc < 1)
           error("too few arguments");
        chktype(argc-1,DT_INTEGER);
        proc = (FARPROC) sp[argc-1].v.v_far;
   procargc = argc-1;
        pargs = (long*) getmemory(argc * sizeof(long));
        for (i=0;i<argc-1;++i)
           pargs[i] = sp[i].v.v_integer;

         asm {
                                push di
                                mov cx, procargc
                        mov di,pargs
                                cmp cx, 0
                                je docall
#ifndef __WATCOMC__
          }
#endif
          nxtarg:
#ifndef __WATCOMC__
          asm {
#endif
                        mov ax, [di]
                        add di, 2
                        mov bx, [di]
                        add di, 2
                        push bx
            push ax
            dec cx
            jnz nxtarg
 #ifndef __WATCOMC__
    }
 #endif
     docall:
#ifndef __WATCOMC__
          asm {
#endif
                        call dword ptr proc
                        mov rl, ax
                        mov rh, dx
                        pop di
                }
         result.lw = rl;
          result.hw = rh;
          sp += argc;
          lresult = *((long*) (void*) &result);
     free(pargs);
     set_integer(&sp[0],lresult);
     return 1;
}

int freelib(int argc)
{
   HDLL plib;
   long result = 1;
   argcount(argc,1);
   chktype(0,DT_INTEGER);
        plib = (HDLL) sp[0].v.v_far;
   if (FreeLibrary(plib) < 0)
      result = 0;
   ++sp;
   set_integer(&sp[0],result);
   return 1;
}

#endif /* ! BP_COMP */
